# 创建
### 创建实体对象
![web dev](./img/web-swager_007.jpg)
例如创建设备实体对象：
```metadata json
{
  "Content": [
    {
      "ProjectId": "Pj1102290001",
      "Category": "TDLS",
      "EquipLocalID": "ATFU-TOP-N-003",
      "EquipLocalName": "低压开关柜-A03"
    }
  ]
}

```
返回结果
```metadata json
{
  "EntityList": [
    {
      "Category": "TDLS",
      "EquipID": "Eq1102290001e2a2b859d59347af99649f7d234384d0",
      "EquipLocalID": "ATFU-TOP-N-003",
      "EquipLocalName": "低压开关柜-A03",
      "EquipName": "低压开关柜-W55EJ",
      "ProjectId": "Pj1102290001"
    }
  ],
  "Message": "",
  "Result": "success"
}
```
创建对象，采用可以单个对象创建，也可以批量创建多个对象，创建返回的结果中会把创建的对象有值得属性返回，例如设备的ID，自动生成的名字都会在返回的结果中