const content = [
    {
        title: "基于 CentOS 安装",
        path: "/setup/server/centos/",
        children: [
            {
                title: "操作系统",
                path: "/setup/server/centos/os/",
                children: [
                    ["/setup/server/centos/os/install", "安装系统"],
                    ["/setup/server/centos/os/config", "配置系统"],
                    ["/setup/server/centos/os/cmd", "常用命令"]
                ]
            },
            {
                title: "基础服务",
                path: "/setup/server/centos/server/",
                children: [
                    ["/setup/server/centos/server/jdk", "JDK"],
                    ["/setup/server/centos/server/python", "Python"],
                    ["/setup/server/centos/server/nginx", "Nginx"],
                    ["/setup/server/centos/server/tomcat", "Tomcat"],
                    ["/setup/server/centos/server/postgresql", "PostgreSQL"],
                    ["/setup/server/centos/server/postgresql-docker", "PostgreSQL(Docker版)"],
                    ["/setup/server/centos/server/docker", "docker"],
                    ["/setup/server/centos/server/kafka", "Kafka"]
                ]
            },
            {
                title: "应用服务",
                path: "/setup/server/centos/app-server/",
                children: [
                    ["/setup/server/centos/app-server/datacenter", "数据中心datacenter"],
                    // ["/setup/server/centos/app-server/pointconfig", "点位配置"],
                    ["/setup/server/centos/app-server/ibms", "用户信息服务ibms"],
                    ["/setup/server/centos/app-server/revit-algorithm", "模型web服务"],
                    ["/setup/server/centos/app-server/scheduler", "模型调度器"],
                    ["/setup/server/centos/app-server/equip-component", "慧云盈定制接口服务equip-component"],
                    ["/setup/server/centos/app-server/dataplatform-sync", "数据同步服务dataplatform-sync"],
                    ["/setup/server/centos/app-server/MBI", "MBI操作流程(孟向歌)"],
                    ["/setup/server/centos/app-server/revit-format", "revit导出数据格式"],
                    ["/setup/server/centos/app-server/revit-service", "revit服务"],
                    ["/setup/server/centos/app-server/revit-check", "模型检查数据格式"],
                    ["/setup/server/centos/app-server/centos-postgresql-plpython3", "centos7 编译安装postgresql"]
                ]
            }
        ]
    },
    {
        title: "基于 Windows 安装",
        path: "/setup/server/windows/",
        children: [
            {
                title: "基础服务",
                path: "/setup/server/windows/server/",
                children: [
                    ["/setup/server/windows/server/jdk", "JDK"],
                    ["/setup/server/windows/server/python", "Python"],
                    ["/setup/server/windows/server/nginx", "Nginx"],
                    ["/setup/server/windows/server/tomcat", "Tomcat"],
                    ["/setup/server/windows/server/mariadb", "MariaDB"],
                    ["/setup/server/windows/server/postgresql", "PostgreSQL"],
                    ["/setup/server/windows/server/navicat", "Navicat"],
                    ["/setup/server/windows/server/kafka", "Kafka"]
                ]
            }
        ]
    }
];

module.exports = content;